org.encog.mathutil.matrices.decomposition

## Class QRDecomposition

- java.lang.Object
- - org.encog.mathutil.matrices.decomposition.QRDecomposition

-     public class QRDecomposition
      extends Object

  QR Decomposition.

  For an m-by-n matrix A with m >= n, the QR decomposition is an m-by-n orthogonal matrix Q and an n-by-n upper triangular matrix R so that A = Q*R.

  The QR decompostion always exists, even if the matrix does not have full rank, so the constructor will never fail. The primary use of the QR decomposition is in the least squares solution of nonsquare systems of simultaneous linear equations. This will fail if isFullRank() returns false. This file based on a class from the public domain JAMA package. http://math.nist.gov/javanumerics/jama/

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `QRDecomposition(Matrix A)` QR Decomposition, computed by Householder reflections.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Matrix` | `getH()` Return the Householder vectors
    `Matrix` | `getQ()` Generate and return the (economy-sized) orthogonal factor
    `Matrix` | `getR()` Return the upper triangular factor
    `boolean` | `isFullRank()` Is the matrix full rank?
    `Matrix` | `solve(Matrix B)` Least squares solution of A*X = B

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### QRDecomposition

          public QRDecomposition(Matrix A)

      QR Decomposition, computed by Householder reflections. Structure to access R and the Householder vectors and compute Q.
      Parameters:
        `A` - Rectangular matrix

  - ### Method Detail

    - #### isFullRank

          public boolean isFullRank()

      Is the matrix full rank?
      Returns:
        true if R, and hence A, has full rank.

    - #### getH

          public Matrix getH()

      Return the Householder vectors
      Returns:
        Lower trapezoidal matrix whose columns define the reflections

    - #### getR

          public Matrix getR()

      Return the upper triangular factor
      Returns:
        R

    - #### getQ

          public Matrix getQ()

      Generate and return the (economy-sized) orthogonal factor
      Returns:
        Q

    - #### solve

          public Matrix solve(Matrix B)

      Least squares solution of A*X = B
      Parameters:
        `B` - A Matrix with as many rows as A and any number of columns.
      Returns:
        X that minimizes the two norm of Q*R*X-B.
      Throws:
        `IllegalArgumentException` - Matrix row dimensions must agree.
        `RuntimeException` - Matrix is rank deficient.

Copyright © 2014. All Rights Reserved.